/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sila114_db;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * @author Simon
 */
public class ComputerSystem
{

    private final String name;
    private final String ram;
    private final String cpu;
    private final String mainboard;
    private final String pcCase;
    private final String gpu;

    public ComputerSystem(String name, String cpu, String ram, String gpu, String pcCase, String mainboard)
    {
        this.name = name;
        this.cpu = cpu;
        this.ram = ram;
        this.gpu = gpu;
        this.pcCase = pcCase;
        this.mainboard = mainboard;
    }

    public int productionLimitingFactor(Connection conn)
    {
        int result = 0;
        try
        {
            Statement st = conn.createStatement();
            ResultSet rs = st.executeQuery("SELECT min(current_stock) FROM component"
                    + " WHERE name='" + cpu + "' OR name='" + ram + "' OR name='" + gpu + "'OR name='" + pcCase + "' OR name='" + mainboard + "'");
            if (rs.next())
            {
                result = rs.getInt(1);
            }

        } catch (SQLException ex)
        {
            System.out.println("Failed to get production limiting factor: " + ex);
        }

        return result;
    }

    public int getPriceOffer(int quantity, Connection conn)
    {
        int priceOffer = 0;
        try
        {
            Statement st = conn.createStatement();
            ResultSet rs = st.executeQuery("SELECT price FROM component"
                    + " WHERE name='" + cpu + "' OR name='" + ram + "' OR name='" + gpu + "'OR name='" + pcCase + "' OR name='" + mainboard + "'");
            while (rs.next())
            {
                priceOffer += rs.getInt("price");
            }
            rs.close();
            st.close();
            priceOffer *= HardwareStockConsts.SELLING_PRICE * quantity;
            priceOffer = calcDiscount(priceOffer, quantity);
            priceOffer = Utilities.roundUpHundredths(priceOffer);
        } catch (SQLException ex)
        {
            System.out.println("Failed to get price offer: " + ex);
        }

        return priceOffer;
    }

    private int calcDiscount(int priceOffer, int quantity)
    {
        double discount = HardwareStockConsts.DISCOUNT_PER_SYSTEM * quantity;
        if (discount > HardwareStockConsts.MAX_DISCOUNT)
        {
            discount = HardwareStockConsts.MAX_DISCOUNT;
        }
        priceOffer -= priceOffer * discount;
        return priceOffer;
    }

    public int getSellingPrice(Connection con)
    {
        return getPriceOffer(1, con);
    }

    @Override
    public String toString()
    {
        return "ComputerSystem{" + "name=" + name + '}';
    }

    public String getName()
    {
        return name;
    }

    public String getRam()
    {
        return ram;
    }

    public String getCpu()
    {
        return cpu;
    }

    public String getMainboard()
    {
        return mainboard;
    }

    public String getPcCase()
    {
        return pcCase;
    }

    public String getGpu()
    {
        return gpu;
    }
}
