/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sila114_db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 *
 * @author Simon
 */
public class HardwareStock
{

    private static final String url = "jdbc:postgresql://localhost:5432/hardwareStock";
    private static final String username = "simon";
    private static final String password = "simon";

    private Connection conn;

    public static void main(String[] args) throws ClassNotFoundException, SQLException
    {
        HardwareStock hardwareStock = new HardwareStock();
        int choice = 10;
        Scanner in = new Scanner(System.in);
        while (choice > 0)
        {
            System.out.println("Please input a number between 1-6 (7 to list commands and any other number to escape).");
            choice = in.nextInt();
            switch (choice)
            {
                case 1:
                    hardwareStock.listComponents();
                    break;
                case 2:
                    hardwareStock.listComputerSystems();
                    break;
                case 3:
                    List<ComputerSystem> systems = hardwareStock.getComputerSystems();
                    System.out.println("Please select the index of a computer system range is (1-" + systems.size() + ")");
                    int systemChoice = in.nextInt() - 1;
                    System.out.println("Please select how many " + systems.get(systemChoice) + " you want to buy.");
                    int quantity = in.nextInt();
                    int price = hardwareStock.getPriceOffer(systems.get(systemChoice), quantity);
                    System.out.println(quantity + " of " + systems.get(systemChoice).getName() + " will cost " + price);
                    break;
                case 4:
                    List<Component> components = hardwareStock.getComponents();
                    System.out.println("Please select the index of a component range is (1-" + components.size() + ")");
                    int componentChoice = in.nextInt() - 1;
                    System.out.println("Please select how many " + components.get(componentChoice).getName() + " you want to buy.");
                    int quantity2 = in.nextInt();
                    hardwareStock.sellComponent(components.get(componentChoice), quantity2);
                    int price2 = components.get(componentChoice).getSellingPrice() * quantity2;
                    System.out.println(quantity2 + " of " + components.get(componentChoice).getName() + " sold for " + price2);
                    break;
                case 5:
                    List<ComputerSystem> systems2 = hardwareStock.getComputerSystems();
                    System.out.println("Please select the index of a computer system range is (1-" + systems2.size() + ")");
                    int systemChoice2 = in.nextInt() - 1;
                    System.out.println("Please select how many " + systems2.get(systemChoice2).getName() + " you want to buy.");
                    int quantity3 = in.nextInt();
                    hardwareStock.sellComputerSystem(systems2.get(systemChoice2), quantity3);
                    int price3 = systems2.get(systemChoice2).getPriceOffer(quantity3, hardwareStock.conn);
                    System.out.println(quantity3 + " of " + systems2.get(systemChoice2).getName() + " sold for " + price3);
                    break;
                case 6:
                    List<Component> components2 = hardwareStock.getComponents();
                    hardwareStock.listComponents(components2);
                    System.out.println("Please select a range of a components between 1 and " + components2.size() + " (i.e. 5-16 inclusive)");
                    in.nextLine(); // Consume newline left-over
                    String[] range = in.nextLine().split("-");
                    int min = Utilities.numberFromString(range[0]) - 1;
                    int max = Utilities.numberFromString(range[1]);
                    List<Component> chosenComponents = components2.subList(min, max);
                    hardwareStock.restockComponents(chosenComponents);
                    break;
                case 7:
                    System.out.println("1. List all components.");
                    System.out.println("2. List all computer systems.");
                    System.out.println("3. Get price offer.");
                    System.out.println("4. Buy component.");
                    System.out.println("5. Buy computer system.");
                    System.out.println("6. Restock components.");
                    break;
                default:
                    choice = 0;
                    break;
            }
            System.out.println("___________________________________");
        }
    }

    public HardwareStock() throws ClassNotFoundException
    {
        Class.forName("org.postgresql.Driver");
        try
        {
            conn = DriverManager.getConnection(url, username, password);
        } catch (SQLException ex)
        {
            System.out.println("SQLException: " + ex);
        }
    }

    public void listComponents()
    {
        try
        {
            listComponents(getComponents());
        } catch (SQLException ex)
        {
            System.out.println("Failed to list components: " + ex);
        }
    }

    public void listComponents(List<Component> components)
    {
        for (int i=0; i<components.size(); i++)
        {
            System.out.println(i+1 + ": " + components.get(i));
        }
    }

    public void listComputerSystems()
    {
        try
        {
            for (ComputerSystem computerSystem : getComputerSystems())
            {
                System.out.println(computerSystem.getName() + " could be built " + computerSystem.productionLimitingFactor(conn) + " times. At " + computerSystem.getSellingPrice(conn) + ",- a piece.");
            }
        } catch (SQLException ex)
        {
            System.out.println("Failed to list computer systems: " + ex);
        }
    }

    public void printPriceList()
    {
        listComponents();
        listComputerSystems();
    }

    private List<Component> getComponents() throws SQLException
    {
        List<Component> components = new ArrayList();

        Statement st = conn.createStatement();
        ResultSet rs = st.executeQuery("SELECT name, current_stock, price FROM component");
        while (rs.next())
        {
            String name = rs.getString("name");
            int currentStock = rs.getInt("current_stock");
            int price = rs.getInt("price");
            Component component = new Component(name, currentStock, price);
            components.add(component);
        }
        rs.close();
        st.close();

        return components;
    }

    public List<ComputerSystem> getComputerSystems() throws SQLException
    {
        List<ComputerSystem> computerSystems = new ArrayList();

        Statement st = conn.createStatement();
        ResultSet rs = st.executeQuery("SELECT name, gpu, cpu, ram, mainboard, pc_case FROM computer_system");
        while (rs.next())
        {
            String name = rs.getString("name");
            String cpu = rs.getString("cpu");
            String ram = rs.getString("ram");
            String gpu = rs.getString("gpu");
            String pcCase = rs.getString("pc_case");
            String mainboard = rs.getString("mainboard");
            ComputerSystem computerSystem = new ComputerSystem(name, cpu, ram, gpu, pcCase, mainboard);
            computerSystems.add(computerSystem);
        }
        rs.close();
        st.close();

        return computerSystems;
    }

    public int getPriceOffer(ComputerSystem computerSystem, int quantity) throws SQLException
    {
        return computerSystem.getPriceOffer(quantity, conn);
    }

    public void sellComponent(Component component, int quantity)
    {
        sellComponent(component.getName(), quantity);
    }

    public void sellComponent(String name, int quantity)
    {
        try
        {
            Statement st = conn.createStatement();
            st.executeUpdate("UPDATE component SET current_stock = current_stock - " + quantity
                    + " WHERE name='" + name + "'");
        } catch (SQLException ex)
        {
            System.out.println("Failed to sell component: " + ex);
        }
    }

    public void sellComputerSystem(ComputerSystem computerSystem, int quantity)
    {
        sellComponent(computerSystem.getCpu(), quantity);
        sellComponent(computerSystem.getGpu(), quantity);
        sellComponent(computerSystem.getMainboard(), quantity);
        sellComponent(computerSystem.getPcCase(), quantity);
        sellComponent(computerSystem.getRam(), quantity);
    }

    public void restockComponents(List<Component> components)
    {
        for (Component component : components)
        {
            System.out.println("restocking component " + component);
            try
            {
                Statement st = conn.createStatement();
                st.executeUpdate("UPDATE component SET current_stock = pref_stock"
                        + " WHERE name='" + component.getName() + "'");
            } catch (SQLException ex)
            {
                System.out.println("Failed to sell component: " + ex);
            }
        }
    }
}
